﻿:root {
    --body-background-color: whitesmoke;
}

body {
    background-color: var(--body-background-color);
}

.bg-gray {
    background-color: gray !important;
}

.cursor-pointer {
    cursor: pointer;
}

.cursor-default {
    cursor: default;
}

.cursor-cell {
    cursor: cell;
}

.cursor-crosshair {
    cursor: crosshair;
}

.float-border-label {
    height: 100%;
    display: flex;
    justify-content: start;
    align-items: center;
}



    .float-border-label label {
        position: absolute;
        font-size: 1rem;
        right: 0;
        top: 50%;
        transform: translateY(-50%);
        /*background-color: var(--body-background-color);*/
        /*color: gray;*/
        padding: 0 0.3rem;
        margin: 0 0.5rem;
        transition: 0.1s ease-out;
        transform-origin: left top;
        pointer-events: none;
    }

    .float-border-label input, .float-border-label select {
        font-size: 1rem;
        outline: none;
        border: 1px solid gray;
        border-radius: 5px;
        padding: 0.6rem 0.6rem;
        /*color: gray;*/
        transition: 0.1s ease-out;
        /*background-color: var(--body-background-color);*/
    }

    .float-border-label select {
        min-width: 90px;
    }

        .float-border-label input:focus,
        .float-border-label select:focus {
            /*color: darkgreen;*/
            border: none;
        }

            .float-border-label input:focus + label,
            .float-border-label select:focus + label {
                /*color: darkgreen;*/
                top: 0;
                transform: translateY(-50%) scale(0.9) !important;
            }

        .float-border-label input:not(:placeholder-shown) + label,
        .float-border-label select[data-hv=True] + label {
            top: 0;
            transform: translateY(-50%) scale(0.9) !important;
        }

    .float-border-label input:not(:focus)::placeholder {
        opacity: 0;
    }

    .float-border-label input:focus::placeholder {
        opacity: 0;
    }

/* Chrome, Safari, Edge, Opera */
input.hide-spin::-webkit-outer-spin-button,
input.hide-spin::-webkit-inner-spin-button {
    -webkit-appearance: none;
    margin: 0;
}

/* Firefox */
input[type=number].hide-spin {
    -moz-appearance: textfield;
}

.required {
    border-color: rgba(255,193,7,.7);
    background-color: rgba(255,193,7,.07);
}

.rotate-45 {
    transform: rotate(45deg);
}

.tree-node {
    list-style-type: none;
    padding-inline-start: 32px;
}

.m-w-400 {
    min-width: 400px;
}

.m-w-32 {
    min-width: 32px;
}

.m-h-300 {
    min-height: 300px;
}

.m-h-32 {
    min-height: 32px;
}

.resize-both {
    resize: both;
}

.hover-bg-highlight:hover {
    background-color: Highlight;
    color: white !important;
    border-radius: var(--bs-border-radius);
}

.disabled {
    pointer-events: none;
    background-color: #e9ecef;
}

.read-only {
    pointer-events: none;
}

select.read-only {
    background-color: #e9ecef;
}

.hidden-input {
    margin: 0;
    padding: 0;
    border: 0;
    width: 0;
    height: 0;
    z-index: -1;
    position: absolute;
    opacity: 0;
    min-height: auto;
    min-width: auto;
}

.valid.modified:not([type=checkbox]) {
    outline: 1px solid #26b050;
}

.invalid {
    outline: 1px solid #e50000;
}

.validation-message {
    color: #e50000;
}

.form-control:focus {
    color: #495057;
    background-color: #fff;
    border-color: #80bdff;
    outline: 0;
    box-shadow: inset 0 0 0 transparent;
}

.main-footer {
    background: #fff !important;
}

.card-header {
    background-color: transparent;
}

.w-1ch {
    width: 1ch;
}

.w-2ch {
    width: 2ch;
}

.w-5ch {
    width: 5ch;
}

.w-10ch {
    width: 10ch;
}

.w-15ch {
    width: 15ch;
}

.w-20ch {
    width: 20ch;
}

.h-calc-25 {
    height: calc(25%);
}

.h-calc-33 {
    height: calc(33%) !important;
}

.h-calc-50 {
    height: calc(50%);
}

.h-calc-66 {
    height: calc(66%);
}

.h-calc-75 {
    height: calc(75%);
}

.h-calc-100 {
    height: calc(100%);
}

.w-calc-25 {
    width: calc(25%);
}

.w-calc-33 {
    width: calc(33%);
}

.w-calc-50 {
    width: calc(50%);
}

.w-calc-66 {
    width: calc(66%);
}

.w-calc-75 {
    width: calc(75%);
}

.w-calc-100 {
    width: calc(100%);
}

.h-33 {
    height: 33%;
}

.h-66 {
    height: 66%;
}

.w-33 {
    width: 33%;
}

.w-66 {
    width: 66%;
}

.w-20 {
    width: 20%;
}

.flex-grid-frame {
    height: 100%;
    padding: .2rem;
    border: solid 1px lightgray;
    background-color: aliceblue;
    display: flex;
    flex-direction: column;
}

.flex-grid-container {
    height: 128px;
    overflow: auto;
    flex-grow: 1;
    border: 1px solid #ccc;
    position: relative;
}

.flex-grid {
    display: flex;
    flex-direction: column;
    flex-wrap: wrap;
    min-width: 128px;
}

.flex-grid-header, .flex-grid-footer, .flex-grid-row-head {
    position: sticky;
    align-items: center;
    color: white;
}

.flex-grid-header, .flex-grid-footer {
    z-index: 2;
}

.flex-grid-header {
    top: 0;
}

.flex-grid-row-head {
    z-index: 1;
    background-color: darkblue;
}

.flex-grid-footer {
    bottom: 0;
}

.flex-grid-col, .flex-grid-cell {
    padding: 1px 3px;
    align-items: center;
}

.flex-grid-col {
    display: flex;
    background-color: darkblue;
}

.flex-grid-col-cell {
    font-weight: bold;
    display: flex;
    width: 100%;
}

.flex-grid-checked-cell, .flex-grid-checked-col {
}

.flex-grid-freeze-col {
    position: sticky;
    z-index: 2;
}

.flex-grid-freeze-cell {
    position: sticky;
    z-index: 1;
    background-color: inherit;
}

.flex-grid-row:hover {
    background-color: lightblue;
}

.odd-row {
    background-color: lightsteelblue;
}

.even-row {
    background-color: lightskyblue;
}

.filter-row {
    background-color: steelblue;
}

.flex-grid-selected-row, .flex-grid-selected-row:hover {
    background-color: royalblue;
}

.group-box {
    margin: 9px;
    border: 1px solid lightgray;
    padding: 9px;
    border-radius: 5px;
    position: relative;
}

.group-box-header {
    position: absolute;
    top: -1.5ch;
    font-size: 16px;
}

.group-box-title {
    background-color: white;
    padding: 2px;
}

.fs-7 {
    font-size: .75rem !important;
}

.rtl {
    direction: rtl;
}
